Unit Win95Functions;

//////////////////////////////////////////
// Soubor: WIN95FUNCTIONS.PAS           //
// Verze:  1.0                          //
// Autor:  Vrtule (vrtulex@seznam.cz)   //
// Popis:  Importn unita pro           //
//         Win9xFunctions.dll           //
//////////////////////////////////////////

Interface

Uses Windows;

// Konstany pro Pstup k vlknm pomoc
// Win95OpenThread
Const THREAD_QUERY_INFORMATION    = $40;
      THREAD_SET_INFORMATION      = $20;
      THREAD_SET_THREAD_CONTEXT   = $80;
      THREAD_SUSPEND_RESUME       = $2;
      THREAD_TERMINATE            = $1;
      THREAD_ALL_ACCESS           = $1F03FF;
      THREAD_GET_CONTEXT          = $8;
      THREAD_DIRECT_IMPRESONATION = $200;
      THREAD_IMPERSONATE          = $100;
      THREAD_SET_CONTEXT          = $10;
      THREAD_SYNCHRONIZE          = $100000;

      Win9xFunctionsLib           = 'WIN9XFUNCTIONS.DLL';

// Uvoln pam alokovanou funkc
// Win95VirtualAllocEx
// Parametry jsou stejn jako ve VirtualFree
Function   Win95VirtualFreeEx(lpAddress:Pointer; dwSize:DWORD; dwFreeType:DWORD):Boolean;
// Alokuje pam sdlenou mezi vemi
// procesy (trochu obdoba VirtualAllocEx)
// Parametry jsou stejn jako u
// VirtualAlloc
Function   Win95VirtualAllocEx(lpAddress:Pointer; dwSize:DWORD; fAllocationType:DWORD; flProtect:DWORD):Pointer;
// Vlo modul do procesu
// PID        - id procesu
// ModuleName - cel nzev souboru modulu
Function   Win98InjectModule(PID:Cardinal; ModuleName:PChar):DWORD;
// Provd to sam jako CreateRemoteThread
// ve Windows NT
// PID - id procesu
// Start - adresa startu vlkna
// Parameter - parametr pedan hlavn
// rutin vlkna
// Vrt Handle vlkna
Function   Win98CreateRemoteThread(PID:Cardinal; Start:Pointer; Parameter:Pointer):THandle;
// Ukon proces pomoc ExitProcess
// PID - id procesu
Procedure  Win98TerminateProcess(PID:Cardinal);
// Odstran modul z procesu
// PID - id procesu
// BaseAddr - adresa v pamti, kde je modul nahrn
Procedure  Win98RemoveModule(PID:Cardinal; BaseAddr:Pointer);
// Dl to sam jako OpenThread ve
// Windows NT. Parametry jsou tak stejn
Function   Win95OpenThread(Access:DWORD; Inherit:Boolean; TID:DWORD):THandle; StdCall;

Implementation

Function GetObsFucator:DWORD;
Var PID, PDB : DWORD;
begin
PID:=GetCurrentProcessID;
Asm
MOV EAX, FS:[30h]
MOV PDB, EAX
end;
Result:= PDB Xor PID;
end;

Function GetPDB(PID:DWORD):Pointer;
begin
Result:=Pointer(PID Xor GetObsFucator);
end;


Function Win95VirtualAllocEx(lpAddress:Pointer; dwSize:DWORD; fAllocationType:DWORD; flProtect:DWORD):Pointer;
Const VA_SHARED = $8000000;
begin
Result:=VirtualAlloc(lpAddress,dwSize,fAllocationType Or VA_SHARED,flProtect);
end;

Function Win95VirtualFreeEx(lpAddress:Pointer; dwSize:DWORD; dwFreeType:DWORD):Boolean;
begin
Result:=VirtualFree(lpAddress,dwSize,dwFreeType);
end;

Function  Win98CreateRemoteThread(PID:Cardinal; Start:Pointer; Parameter:Pointer):THandle;
Var Pom : DWORD;
begin
 Asm
 PUSH PID
 CALL GetPDB
 PUSH 00000048h
 MOV EDI, Parameter
 PUSH EDI
 PUSH Start
 PUSH -00003000h
 MOV EDI, EAX
 PUSH EDI
 MOV EAX, 0BFF929F1h
 CALL EAX
 PUSH EAX
 PUSH 500
 CALL Sleep
 POP EAX
 PUSH EAX
 CALL GetObsfucator
 POP EBX
 XOR EBX, EAX
 MOV EAX, EBX
 MOV Pom, EAX
 PUSH EAX
 PUSH False
 PUSH THREAD_ALL_ACCESS
 CALL Win95OpenThread
 PUSH EAX
 PUSH EAX
 CALL ResumeThread
 POP EAX
 MOV Result, EAX
 POP EAX
 MOV Result, EAX
 end;
end;

Function  Win98InjectModule(PID:Cardinal; ModuleName:PChar):DWORD;
Var Addr     : Pointer;
    hProcess : THandle;
    Written  : Cardinal;
    LoadLibA : Pointer;
    hKernel  : THandle;
    hThread  : THandle;
begin
Result:=0;
hProcess:=OpenProcess(PROCESS_VM_OPERATION Or PROCESS_VM_WRITE Or PROCESS_CREATE_THREAD,False,PID);
If hProcess > 0 Then
   begin
   Addr:=Win95VirtualAllocEx(Nil,Length(ModuleName)+1,MEM_COMMIT,PAGE_EXECUTE_READWRITE);
   If Assigned(Addr) Then
      begin
      WriteProcessMemory(hProcess,Addr,ModuleName,Length(ModuleName),Written);
      If Written = Cardinal(Length(ModuleName)) Then
         begin
         hKernel:=GetModuleHandle('KERNEL32.DLL');
         If hKernel > 0 Then
            begin
            LoadLibA:=GetProcAddress(hKernel,'LoadLibraryA');
            If Assigned(LoadLibA) Then
               begin
               hThread:=Win98CreateRemoteThread(PID,LoadLibA,Addr);
               GetExitCodeThread(hThread,Result);
               end;
            end;
         end;
      Sleep(1000);
      Win95VirtualFreeEx(Addr,Length(ModuleName),MEM_DECOMMIT);
      end;
   CloseHandle(hProcess);
   end;
end;

Procedure Win98TerminateProcess(PID:Cardinal);
Var EP : Pointer;
    hProcess : THandle;
begin
EP:=GetProcAddress(GetModuleHandle('KERNEL32.DLL'),'ExitProcess');
If Assigned(EP) Then
   begin
   Win98CreateRemoteThread(PID,EP,Pointer(25));
   Sleep(500);
   end;
end;

Procedure Win98RemoveModule(PID:Cardinal; BaseAddr:Pointer);
Var FreeLib : Pointer;
    hKernel : THandle;
    hThread : THandle;
begin
Asm
PUSHAD
end;
hKernel:=GetModuleHandle('KERNEL32.DLL');
If hKernel > 0 Then
   begin
   FreeLib:=GetProcAddress(hKernel,'FreeLibrary');
   If Assigned(FreeLib) Then
      hThread:=Win98CreateRemoteThread(PID,FreeLib,BaseAddr);
   WaitForSingleObject(hThread,1000);
   CloseHandle(hThread);
   end;
Asm
POPAD
end;
end;

Function   Win95OpenThread(Access:DWORD; Inherit:Boolean; TID:DWORD):THandle; StdCall;
Var pTDB : Pointer;
begin
pTDB:=Pointer(TID Xor GetObsfucator);
Asm
(*
BFF730B8*
BFF84F1E*
BFF95D90****
BFF9D696*
BFF9D7A1*
BFFB99E1*
BFFB99FF*
BFFB9BD7*
BFFB9BF5*
BFFBC80B*
BFFBD522*
BFFBD74A*
BFFBCF6B*
BFFBCF9B*
BFFBCFF4*
BFFBFCE4*
BFFBD95C*
BFFBDB52*
*)
MOV EAX , pTDB
PUSH TID
PUSH 00000000h
PUSH Access
MOV EDI, 0BFF95D90h
CALL EDI
MOV Result, EAX
end;
end;

End.
